#!/bin/sh

#clashNG's system initialization script

PATH=/sbin:/usr/sbin:/bin:/usr/bin
export PATH

mount -v proc /proc -n -t proc 2> /dev/null

if [ -d /sys ] 
then
  if grep -wq sysfs /proc/filesystems 
  then
    if ! grep -wq sysfs /proc/mounts 
    then
       mount -v sysfs /sys -n -t sysfs
     fi
  fi
fi

if grep -wq sysfs /proc/mounts && grep -q tmpfs /proc/filesystems 
then
  if ! grep -wq nohotplug /proc/cmdline 
  then
    if [ -x /etc/rc.d/rc.udev ] 
    then
      sh /etc/rc.d/rc.udev start
    fi
  fi
fi

swapon -a 2> /dev/null

if [ -x /etc/rc.d/rc.modules -a -r /proc/modules ] 
then
  echo "Running /etc/rc.d/rc.modules:"
  . /etc/rc.d/rc.modules
fi

if [ -x /sbin/sysctl -a -r /etc/sysctl.conf ] 
then
  sysctl -e -p /etc/sysctl.conf
fi   

if grep -wq usbfs /proc/filesystems 
then
  if ! grep -wq usbfs /proc/mounts 
  then
    if ! grep -wq usbfs /etc/fstab 
    then
      mount -v usbfs /proc/bus/usb -t usbfs
    else
      mount -v /proc/bus/usb
    fi
  fi
fi

echo "Mounting non-root local filesystems:"
sleep 3
if grep -wq devpts /proc/mounts 
then
  mount -a -v -t nonfs,nosmbfs,nocifs,noproc,nosysfs,nodevpts
else
  mount -a -v -t nonfs,nosmbfs,nocifs,noproc,nosysfs
fi

echo "Making var writable via tmpfs"
[ ! -d /tmp/var ] && mkdir /tmp/var
[ ! -d /tmp/media ] && mkdir /tmp/media
sleep 1
mount --bind /tmp/var /var
mount --bind /tmp/media /media
( cd /var
  CWD=$(pwd)
  cat /real_var/resolv.conf > ./resolv.conf
  mkdir  -p ./lib/php
  mkdir -p ./log/httpd
  touch ./log/wtmp
  touch ./log/lastlog
  chmod 664 ./log/wtmp ./log/lastlog
  mkdir -p ./run/httpd
  chown root:daemon ./run
  touch ./run/utmp
  chown root:utmp ./run/utmp
  chmod 664 ./run/utmp
  mkdir -p ./run/hostapd
  mkdir -p ./spool/atjobs
  mkdir -p ./spool/atspool
  touch ./spool/atjobs/.SEQ
  chmod 660 ./spool/atjobs/.SEQ
  chown daemon.daemon ./spool/atjobs/.SEQ
  chown daemon.daemon ./spool/atjobs ./spool/atspool
  mkdir -p ./state/dnsmasq
  ln -s ../real_var/www ./www
)

